scriptname SummonArmy20 extends ActiveMagicEffect
 
Quest property GuardPlacementQuest auto
{We need a reference to our quest with the threads and Thread Manager defined.}
ActorBase property Guard auto

ObjectReference Guard1
ObjectReference Guard2
ObjectReference Guard3
ObjectReference Guard4
ObjectReference Guard5
ObjectReference Guard6
ObjectReference Guard7
ObjectReference Guard8
ObjectReference Guard9
ObjectReference Guard10
ObjectReference Guard11
ObjectReference Guard12
ObjectReference Guard13
ObjectReference Guard14
ObjectReference Guard15
ObjectReference Guard16
ObjectReference Guard17
ObjectReference Guard18
ObjectReference Guard19
ObjectReference Guard20
 
Event OnEffectStart(Actor akTarget, Actor akCaster)
	if akCaster == Game.GetPlayer()
 		float start_time = Utility.GetCurrentRealTime()

		;Cast the Quest as our Thread Manager and store it
		GuardPlacementThreadManager threadmgr = GuardPlacementQuest as GuardPlacementThreadManager

		;For the purposes of this test, we have the same number of threads as guards to spawn,
		;so things should happen rather fast.
		threadmgr.thread_limit = 20

		;Register for the callback event
		RegisterForModEvent("MyMod_GuardPlacementCallback", "GuardPlacementCallback")

		;Call PlaceConjuredGuardAsync for each Guard
		threadmgr.PlaceConjuredGuardAsync(Guard)
		threadmgr.PlaceConjuredGuardAsync(Guard)
		threadmgr.PlaceConjuredGuardAsync(Guard)
		threadmgr.PlaceConjuredGuardAsync(Guard)
		threadmgr.PlaceConjuredGuardAsync(Guard)
		threadmgr.PlaceConjuredGuardAsync(Guard)
		threadmgr.PlaceConjuredGuardAsync(Guard)
		threadmgr.PlaceConjuredGuardAsync(Guard)
		threadmgr.PlaceConjuredGuardAsync(Guard)
		threadmgr.PlaceConjuredGuardAsync(Guard)
		threadmgr.PlaceConjuredGuardAsync(Guard)
		threadmgr.PlaceConjuredGuardAsync(Guard)
		threadmgr.PlaceConjuredGuardAsync(Guard)
		threadmgr.PlaceConjuredGuardAsync(Guard)
		threadmgr.PlaceConjuredGuardAsync(Guard)
		threadmgr.PlaceConjuredGuardAsync(Guard)
		threadmgr.PlaceConjuredGuardAsync(Guard)
		threadmgr.PlaceConjuredGuardAsync(Guard)
		threadmgr.PlaceConjuredGuardAsync(Guard)
		threadmgr.PlaceConjuredGuardAsync(Guard)
		threadmgr.wait_all()
 
		float end_time = Utility.GetCurrentRealTime()

		float time_delta = end_time - start_time
		debug.notification("Script completed in " + time_delta + " seconds.")
		debug.trace("[Future] (20 Threads) Script completed in " + time_delta + " seconds.")
	endif
endEvent

Event OnEffectFinish(Actor akTarget, Actor akCaster)
	if akCaster == Game.GetPlayer()
		DisableAndDelete(Guard1)
		DisableAndDelete(Guard2)
		DisableAndDelete(Guard3)
		DisableAndDelete(Guard4)
		DisableAndDelete(Guard5)
		DisableAndDelete(Guard6)
		DisableAndDelete(Guard7)
		DisableAndDelete(Guard8)
		DisableAndDelete(Guard9)
		DisableAndDelete(Guard10)
		DisableAndDelete(Guard11)
		DisableAndDelete(Guard12)
		DisableAndDelete(Guard13)
		DisableAndDelete(Guard14)
		DisableAndDelete(Guard15)
		DisableAndDelete(Guard16)
		DisableAndDelete(Guard17)
		DisableAndDelete(Guard18)
		DisableAndDelete(Guard19)
		DisableAndDelete(Guard20)
	endif
endEvent

bool locked = false
Event GuardPlacementCallback(Form akGuard)
	;A spin lock is required here to prevent us from writing two guards to the same variable
	while locked
		Utility.wait(0.1)
	endWhile
	locked = true

	ObjectReference myGuard = akGuard as ObjectReference

	debug.trace("[Callback] Assigning " + myGuard + "...")
	if !Guard1
		Guard1 = myGuard
	elseif !Guard2
		Guard2 = myGuard
	elseif !Guard3
		Guard3 = myGuard
	elseif !Guard4
		Guard4 = myGuard
	elseif !Guard5
		Guard5 = myGuard
	elseif !Guard6
		Guard6 = myGuard
	elseif !Guard7
		Guard7 = myGuard
	elseif !Guard8
		Guard8 = myGuard
	elseif !Guard9
		Guard9 = myGuard
	elseif !Guard10
		Guard10 = myGuard
	elseif !Guard11
		Guard11 = myGuard
	elseif !Guard12
		Guard12 = myGuard
	elseif !Guard13
		Guard13 = myGuard
	elseif !Guard14
		Guard14 = myGuard
	elseif !Guard15
		Guard15 = myGuard
	elseif !Guard16
		Guard16 = myGuard
	elseif !Guard17
		Guard17 = myGuard
	elseif !Guard18
		Guard18 = myGuard
	elseif !Guard19
		Guard19 = myGuard
	elseif !Guard20
		Guard20 = myGuard
	endif

	locked = false
endEvent

function DisableAndDelete(ObjectReference akReference)
	akReference.Disable()
	akReference.Delete()
endFunction