scriptname SummonArmySingleThread extends ActiveMagicEffect
{Single thread version of SummonArmy.}

Quest property GuardPlacementQuest auto
{We need a reference to our quest with the threads and Thread Manager defined.}
ActorBase property Guard auto
Static property XMarker auto
Actor property PlayerRef auto

ObjectReference Guard1
ObjectReference Guard2
ObjectReference Guard3
ObjectReference Guard4
ObjectReference Guard5
ObjectReference Guard6
ObjectReference Guard7
ObjectReference Guard8
ObjectReference Guard9
ObjectReference Guard10
ObjectReference Guard11
ObjectReference Guard12
ObjectReference Guard13
ObjectReference Guard14
ObjectReference Guard15
ObjectReference Guard16
ObjectReference Guard17
ObjectReference Guard18
ObjectReference Guard19
ObjectReference Guard20
 
Event OnEffectStart(Actor akTarget, Actor akCaster)
	if akCaster == Game.GetPlayer()
		;Place actors randomly around the player's position.
		float start_time = Utility.GetCurrentRealTime()
 
 		ObjectReference tempMarker = PlayerRef.PlaceAtMe(XMarker)
		
		MoveGuardMarkerNearPlayer(tempMarker)
		Guard1 = tempMarker.PlaceAtMe(Guard)
		MoveGuardMarkerNearPlayer(tempMarker)
		Guard2 = tempMarker.PlaceAtMe(Guard)
		MoveGuardMarkerNearPlayer(tempMarker)
		Guard3 = tempMarker.PlaceAtMe(Guard)
		MoveGuardMarkerNearPlayer(tempMarker)
		Guard4 = tempMarker.PlaceAtMe(Guard)
		MoveGuardMarkerNearPlayer(tempMarker)
		Guard5 = tempMarker.PlaceAtMe(Guard)
		MoveGuardMarkerNearPlayer(tempMarker)
		Guard6 = tempMarker.PlaceAtMe(Guard)
		MoveGuardMarkerNearPlayer(tempMarker)
		Guard7 = tempMarker.PlaceAtMe(Guard)
		MoveGuardMarkerNearPlayer(tempMarker)
		Guard8 = tempMarker.PlaceAtMe(Guard)
		MoveGuardMarkerNearPlayer(tempMarker)
		Guard9 = tempMarker.PlaceAtMe(Guard)
		MoveGuardMarkerNearPlayer(tempMarker)
		Guard10 = tempMarker.PlaceAtMe(Guard)
		MoveGuardMarkerNearPlayer(tempMarker)
		Guard11 = tempMarker.PlaceAtMe(Guard)
		MoveGuardMarkerNearPlayer(tempMarker)
		Guard12 = tempMarker.PlaceAtMe(Guard)
		MoveGuardMarkerNearPlayer(tempMarker)
		Guard13 = tempMarker.PlaceAtMe(Guard)
		MoveGuardMarkerNearPlayer(tempMarker)
		Guard14 = tempMarker.PlaceAtMe(Guard)
		MoveGuardMarkerNearPlayer(tempMarker)
		Guard15 = tempMarker.PlaceAtMe(Guard)
		MoveGuardMarkerNearPlayer(tempMarker)
		Guard16 = tempMarker.PlaceAtMe(Guard)
		MoveGuardMarkerNearPlayer(tempMarker)
		Guard17 = tempMarker.PlaceAtMe(Guard)
		MoveGuardMarkerNearPlayer(tempMarker)
		Guard18 = tempMarker.PlaceAtMe(Guard)
		MoveGuardMarkerNearPlayer(tempMarker)
		Guard19 = tempMarker.PlaceAtMe(Guard)
		MoveGuardMarkerNearPlayer(tempMarker)
		Guard20 = tempMarker.PlaceAtMe(Guard)

		tempMarker.Disable()
		tempMarker.Delete()

		float end_time = Utility.GetCurrentRealTime()

		float time_delta = end_time - start_time
		debug.notification("Script completed in " + time_delta + " seconds.")
		debug.trace("[Future] (1 Thread) Script completed in " + time_delta + " seconds.")
	endif
endEvent
 
Event OnEffectFinish(Actor akTarget, Actor akCaster)
	if akCaster == Game.GetPlayer()
		DisableAndDelete(Guard1)
		DisableAndDelete(Guard2)
		DisableAndDelete(Guard3)
		DisableAndDelete(Guard4)
		DisableAndDelete(Guard5)
		DisableAndDelete(Guard6)
		DisableAndDelete(Guard7)
		DisableAndDelete(Guard8)
		DisableAndDelete(Guard9)
		DisableAndDelete(Guard10)
		DisableAndDelete(Guard11)
		DisableAndDelete(Guard12)
		DisableAndDelete(Guard13)
		DisableAndDelete(Guard14)
		DisableAndDelete(Guard15)
		DisableAndDelete(Guard16)
		DisableAndDelete(Guard17)
		DisableAndDelete(Guard18)
		DisableAndDelete(Guard19)
		DisableAndDelete(Guard20)
	endif
endEvent

function DisableAndDelete(ObjectReference akReference)
	akReference.Disable()
	akReference.Delete()
endFunction

function MoveGuardMarkerNearPlayer(ObjectReference akMarker)
	;Move the marker away from the player a random distance and direction in 75.0 game unit increments
	Actor player = Game.GetPlayer()
	Float playerX = player.GetPositionX()
	Float playerY = player.GetPositionY()
	Float playerZ = player.GetPositionZ()
	Float A = player.GetAngleZ() + (Utility.RandomInt(1, 24) * 15.0)
	Float YDist = math.Sin(A)
	Float XDist = math.Cos(A)
	XDist *= (Utility.RandomInt(1, 5) * 75.0)
	YDist *= (Utility.RandomInt(1, 5) * 75.0)
	;akMarker.MoveTo(player, XDist, YDist)
	akMarker.SetPosition(playerX + XDist, playerY + YDist, playerZ)
EndFunction