scriptname GuardPlacementThreadManager extends Quest
 
Quest property GuardPlacementQuest auto
{The name of the thread management quest.}
 
Static property XMarker auto
{Tedious to define properties in the threads and hook up in CK over and over, so define things we need here. MoveGuardMarkerNearPlayer() needs XMarkers.}

Spell property SummonArmySpellSingleThread auto
Spell property SummonArmySpellMultiThread10 auto
Spell property SummonArmySpellMultiThread20 auto

int property thread_limit = 10 auto hidden

GuardPlacementThread01 thread01
GuardPlacementThread02 thread02
GuardPlacementThread03 thread03
GuardPlacementThread04 thread04
GuardPlacementThread05 thread05
GuardPlacementThread06 thread06
GuardPlacementThread07 thread07
GuardPlacementThread08 thread08
GuardPlacementThread09 thread09
GuardPlacementThread10 thread10
GuardPlacementThread11 thread11
GuardPlacementThread12 thread12
GuardPlacementThread13 thread13
GuardPlacementThread14 thread14
GuardPlacementThread15 thread15
GuardPlacementThread16 thread16
GuardPlacementThread17 thread17
GuardPlacementThread18 thread18
GuardPlacementThread19 thread19
GuardPlacementThread20 thread20
 
Event OnInit()
    ;Register for the event that will start all threads
    ;NOTE - This needs to be re-registered once per load! Use an alias and OnPlayerLoadGame() in a real implementation.
    RegisterForModEvent("MyMod_OnGuardPlacement", "OnGuardPlacement")

    ;Let's cast our threads to local variables so things are less cluttered in our code
    thread01 = GuardPlacementQuest as GuardPlacementThread01
    thread02 = GuardPlacementQuest as GuardPlacementThread02
    thread03 = GuardPlacementQuest as GuardPlacementThread03
    thread04 = GuardPlacementQuest as GuardPlacementThread04
    thread05 = GuardPlacementQuest as GuardPlacementThread05
    thread06 = GuardPlacementQuest as GuardPlacementThread06
    thread07 = GuardPlacementQuest as GuardPlacementThread07
    thread08 = GuardPlacementQuest as GuardPlacementThread08
    thread09 = GuardPlacementQuest as GuardPlacementThread09
    thread10 = GuardPlacementQuest as GuardPlacementThread10
    thread11 = GuardPlacementQuest as GuardPlacementThread11
    thread12 = GuardPlacementQuest as GuardPlacementThread12
    thread13 = GuardPlacementQuest as GuardPlacementThread13
    thread14 = GuardPlacementQuest as GuardPlacementThread14
    thread15 = GuardPlacementQuest as GuardPlacementThread15
    thread16 = GuardPlacementQuest as GuardPlacementThread16
    thread17 = GuardPlacementQuest as GuardPlacementThread17
    thread18 = GuardPlacementQuest as GuardPlacementThread18
    thread19 = GuardPlacementQuest as GuardPlacementThread19
    thread20 = GuardPlacementQuest as GuardPlacementThread20

    ;Give tutorial spells to the player!
    Game.GetPlayer().AddSpell(SummonArmySpellSingleThread)
    Game.GetPlayer().AddSpell(SummonArmySpellMultiThread10)
    Game.GetPlayer().AddSpell(SummonArmySpellMultiThread20)
EndEvent
 
;The 'public-facing' function that our MagicEffect script will interact with.
function PlaceConjuredGuardAsync(ActorBase akGuard)
	if !thread01.queued() && thread_limit >= 1
        debug.trace("[Callback] Selected thread01")
        thread01.get_async(akGuard, XMarker)
	elseif !thread02.queued() && thread_limit >= 2
        debug.trace("[Callback] Selected thread02")
		thread02.get_async(akGuard, XMarker)
    elseif !thread03.queued() && thread_limit >= 3
        debug.trace("[Callback] Selected thread03")
        thread03.get_async(akGuard, XMarker)
    elseif !thread04.queued() && thread_limit >= 4
        debug.trace("[Callback] Selected thread04")
        thread04.get_async(akGuard, XMarker)
    elseif !thread05.queued() && thread_limit >= 5
        debug.trace("[Callback] Selected thread05")
        thread05.get_async(akGuard, XMarker)
    elseif !thread06.queued() && thread_limit >= 6
        debug.trace("[Callback] Selected thread06")
        thread06.get_async(akGuard, XMarker)
    elseif !thread07.queued() && thread_limit >= 7
        debug.trace("[Callback] Selected thread07")
        thread07.get_async(akGuard, XMarker)
    elseif !thread08.queued() && thread_limit >= 8
        debug.trace("[Callback] Selected thread08")
        thread08.get_async(akGuard, XMarker)
	elseif !thread09.queued() && thread_limit >= 9
        debug.trace("[Callback] Selected thread09")
        thread09.get_async(akGuard, XMarker)
	elseif !thread10.queued() && thread_limit >= 10
        debug.trace("[Callback] Selected thread10")
        thread10.get_async(akGuard, XMarker)
    elseif !thread11.queued() && thread_limit >= 11
        debug.trace("[Callback] Selected thread11")
        thread11.get_async(akGuard, XMarker)
    elseif !thread12.queued() && thread_limit >= 12
        debug.trace("[Callback] Selected thread12")
        thread12.get_async(akGuard, XMarker)
    elseif !thread13.queued() && thread_limit >= 13
        debug.trace("[Callback] Selected thread13")
        thread13.get_async(akGuard, XMarker)
    elseif !thread14.queued() && thread_limit >= 14
        debug.trace("[Callback] Selected thread14")
        thread14.get_async(akGuard, XMarker)
    elseif !thread15.queued() && thread_limit >= 15
        debug.trace("[Callback] Selected thread15")
        thread15.get_async(akGuard, XMarker)
    elseif !thread16.queued() && thread_limit >= 16
        debug.trace("[Callback] Selected thread16")
        thread16.get_async(akGuard, XMarker)
    elseif !thread17.queued() && thread_limit >= 17
        debug.trace("[Callback] Selected thread17")
        thread17.get_async(akGuard, XMarker)
    elseif !thread18.queued() && thread_limit >= 18
        debug.trace("[Callback] Selected thread18")
        thread18.get_async(akGuard, XMarker)
    elseif !thread19.queued() && thread_limit >= 19
        debug.trace("[Callback] Selected thread19")
        thread19.get_async(akGuard, XMarker)
    elseif !thread20.queued() && thread_limit >= 20
        debug.trace("[Callback] Selected thread20")
        thread20.get_async(akGuard, XMarker)
	else
		;All threads are queued; start all threads, wait, and try again.
        wait_all()
        PlaceConjuredGuardAsync(akGuard)
	endif
endFunction
 
function wait_all()
    RaiseEvent_OnGuardPlacement()
    begin_waiting()
endFunction

function begin_waiting()
    bool waiting = true
    int i = 0
    while waiting
        if thread01.queued() || thread02.queued() || thread03.queued() || thread04.queued() || thread05.queued() || \
           thread06.queued() || thread07.queued() || thread08.queued() || thread09.queued() || thread10.queued() || \ 
           thread11.queued() || thread12.queued() || thread13.queued() || thread14.queued() || thread15.queued() || \ 
           thread16.queued() || thread17.queued() || thread18.queued() || thread19.queued() || thread20.queued()
            i += 1
            Utility.wait(0.1)
            if i >= 100
                debug.trace("Error: A catastrophic error has occurred. All threads have become unresponsive. Please debug this issue or notify the author.")
                i = 0
                ;Fail by returning None. The mod needs to be fixed.
                return
            endif
        else
            waiting = false
        endif
    endWhile
endFunction

;Create the ModEvent that will start this thread
function RaiseEvent_OnGuardPlacement()
    int handle = ModEvent.Create("MyMod_OnGuardPlacement")
    if handle
        ModEvent.Send(handle)
    else
        ;pass
    endif
endFunction